#include <stdio.h>
#include "Mfont.h"

//  
CMfont::CMfont()
{
	failed=true;
}

CMfont::~CMfont()
	{
	SAFE_DELETE(surface);
	}

//  
void CMfont::LoadFont(char *txtfname, char *bmpfname, CDisplay *idisplay)
{
	FILE *fp;
	char str[16];

	display=idisplay;
	failed=false;
	for (int i=0;i<256;i++)
	{
		c_start[i]=-1;
		c_end[i]=-1;
	}

	//   
	fp=fopen(txtfname,"rt");
	if (!fp)
	{
		failed=true;
		return;
	}
	int phase=0;
	int value;
	int idx=0;
	while (!feof(fp))
	{
		fgets(str,16,fp);
		value=atoi(str);
		if (phase==0) idx=value;
		if (phase==1) c_start[idx]=value;
		if (phase==2) c_end[idx]=value;
		phase++;
		if (phase>2) phase=0;
	}
	fclose(fp);
	//  BMP
	display->CreateSurfaceFromBitmap(&surface,bmpfname,0,0);
	if (!surface) failed=true;
}

// true -  ,   .
bool CMfont::IsFailed(void)
{
	return(failed);
}

// true -  ,   .
void CMfont::SetColorKey(int icolor)
{
	if (failed) return;
	surface->SetColorKey(icolor);
}


//   
void CMfont::Draw(int x, int y, char* istr)
{
	RECT r;

	if (failed) return;
	if (!istr) return;
	int i=0;
	while (istr[i]!=0)
	{
		r.top=0;
		r.bottom=26;
		r.left=c_start[istr[i]];
		r.right=c_end[istr[i]];
		display->Blt(x,y,surface,&r);
		x+=r.right-r.left;
		i++;
	}
}
