#if !defined(AFX_FIELD_H_INCLUDED)
#define AFX_FIELD_H_INCLUDED

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "dx\ddutil.h"
#include "sprite.h"
#include "mfont.h"

#define SCORE_PER_BLOCK 1

extern CMfont* font_big;

class CField
{
public:
	CField(CDisplay* ig_pDisplay, int ilevel);
	~CField();
	void Show(void);
	void BlockOpen(void);
	bool IsFinished(void);
	//  
	void key_Right(void);
	void key_Left(void);
	void key_Up(void);
	void key_Down(void);
	void key_Fire(void);
	void key_Release(void);
	//    
	void FClear(void);
	int  FLineAdd(long itime);
	void FRemove(int count);
	bool FIsDead(void);
	void FDraw(int ix, int iy);
	//    
	void LineAddTo(int i);
	int  LineCheck(void);
	void LineClear(void);
	void LineDraw(int x, int y);
	//   
	void doWin(void);
	void doDie(void);
private:
	int level;
	int block[6][8];	//    (0 -  , 1 -  )
	int f[12][6];		//  (0 - , 1-6 );
	int line[6];		//  
	int player_x;		//  X  ( 0  7)
	int player_v;		//    ( 0  5)
	int player_speed;	//   
	int last_direction; //   

	int add_time;		//     
	int time;			//    FPS
	bool need_show_fps;	//    FPS

	int field_x;		//  X 
	int field_y;		//  Y 

	int fire_x;			//  X  ( 0  5)
	int fire_y;			//  Y  ( 11  0) (-1 - )
	int fire_v;			//  

	int score;			// 
	int open_count;		//   

	bool player_anim;	// True -    ()

	bool changed_bg;	//  true,    
	bool changed_field; //  true,    
	CDisplay* g_pDisplay;
	CSurface *surface_text;
	CSprite* spr_fieldu;
	CSprite* spr_fieldd;
	CSprite* spr_background;
	CSprite* spr_block;
	CSprite* aspr_fire[6];
	CSprite* aspr_fire_anim[6];
};

#endif
