#if !defined(AFX_SPRITE_H_INCLUDED)
#define AFX_SPRITE_H_INCLUDED

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "dx\ddutil.h"

#define WINDOW_WIDTH    640
#define WINDOW_HEIGHT   480
#define MAX_SPRITE_FRAMES 32

class CSprite
{
public:
	CSprite(CDisplay* iwhere_display, int x, int y, int w, int h, TCHAR* strBMP);
	CSprite(CDisplay* iwhere_display, int x, int y, int w, int h, int icolorkey, TCHAR* strBMP);
	CSprite(CDisplay* iwhere_display, int ix, int iy, TCHAR* strBMP);
	~CSprite();

	void AddFrame(TCHAR* strBMP);
	void Show(void);
	void Show(int ix, int iy);
	void SetColorKey(int color);
	void SetX(int ix);
	void SetY(int iy);
	void doHide(void);
	void doShow(void);
	//   
	void SetAnimationDelay(int delay);
	void SetAnimationFPS(int fps);
	void SetAnimationDelay(int delay, int frame_num);
	void SetAnimationFPS(int fps, int frame_num);
	void SetLoopCount(int icount);
	bool IsAlreadyAnimated(void);
	void Rewind(int iframe);

private:
	CDisplay * 	where_display;
	CSurface* surface[MAX_SPRITE_FRAMES];
	int animation_delay[MAX_SPRITE_FRAMES];
	int x;
	int y;
	int width;
	int height;
	int frame_total;
	int 
		frame_curent;
	int colorkey;
	int last_time;
	int loop_total;
	int loop_curent;

	bool visible;
	bool failed;
};

#endif
